<template lang="pug">
.bg-white
  .row.items-center.full-width
    .relative-position
      transition(
        mode='out-in',
        enter-active-class='animate__animated animate__fadeIn animate__fast',
        leave-active-class='animate__animated animate__fadeOut animate__fast'
      )
        Question(
          :key='currentQuestion.name',
          v-if='currentQuestion',
          :currentQuestion='currentQuestion',
          :sequence='checkin.currentQuestion',
          :response='getResponse()',
          :viewOnly='true'
        )
</template>

<script>
import Question from './Question.vue';

export default {
  name: 'CheckinOverlay',
  props: {
    firebase: {
      required: true,
    },
    context: {
      required: false,
    },
  },
  data: () => {
    return {
      checkin: null,
    };
  },
  components: {
    Question,
  },
  methods: {
    getResponse() {
      return this.checkin &&
        this.checkin.responses &&
        typeof this.checkin.responses[this.checkin.currentQuestion] != 'undefined'
        ? this.checkin.responses[this.checkin.currentQuestion]
        : Math.ceil(Object.values(this.currentQuestion.options).length / 2 - 1);
    },
  },
  computed: {
    currentQuestion() {
      // console.log(this.checkin);
      if (this.checkin && this.checkin.questions && this.checkin.questions.length > 0) {
        return this.checkin.questions[this.checkin.currentQuestion || 0];
      }
      return null;
    },
  },
  watch: {
    firebase: {
      immediate: true,
      async handler() {
        // this.$rtdbBind('checkin', this.firebase.ref(`meta/checkin`));

        this.$rtdbBind(
          'checkin',
          this.firebase.ref(`config/${this.context.meetingid}/current/currentState/plugins/checkin`),
        );
      },
    },
  },
};
</script>

<style lang="scss"></style>
